ForwardingSortedMultiset.StandardDescendingMultiset
Date: 2016-05-24

com.google.common.collect

## Class ForwardingSortedMultiset.StandardDescendingMultiset

- java.lang.Object
- - com.google.common.collect.ForwardingObject
  - - com.google.common.collect.ForwardingCollection<E>
    - - com.google.common.collect.ForwardingMultiset<E>
      - - com.google.common.collect.ForwardingSortedMultiset.StandardDescendingMultiset

- All Implemented Interfaces:
    Multiset<E>, SortedMultiset<E>, java.lang.Iterable<E>, java.util.Collection<E>
  Enclosing class:
    ForwardingSortedMultiset<E>

      protected abstract class ForwardingSortedMultiset.StandardDescendingMultiset
      extends ForwardingMultiset<E>

  A skeleton implementation of a descending multiset view. Normally, `descendingMultiset()` will not reflect any changes you make to the behavior of methods such as `ForwardingCollection.add(Object)` or `pollFirstEntry()`. This skeleton implementation correctly delegates each of its operations to the appropriate methods of this `ForwardingSortedMultiset`. In many cases, you may wish to override `descendingMultiset()` to return an instance of a subclass of `StandardDescendingMultiset`.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class com.google.common.collect.ForwardingMultiset

      `ForwardingMultiset.StandardElementSet`

    - ### Nested classes/interfaces inherited from interface com.google.common.collect.Multiset

      `Multiset.Entry<E>`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ForwardingSortedMultiset.StandardDescendingMultiset()` Constructor for use by subclasses.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.util.Comparator<? super E>` | `comparator()` Returns the comparator that orders this multiset, or `Ordering.natural()` if the natural ordering of the elements is used.
    `protected Multiset<E>` | `delegate()` Returns the backing delegate instance that methods are forwarded to.
    `SortedMultiset<E>` | `descendingMultiset()` Returns a descending view of this multiset.
    `java.util.NavigableSet<E>` | `elementSet()` Returns the set of distinct elements contained in this multiset.
    `java.util.Set<Multiset.Entry<E>>` | `entrySet()` Returns a view of the contents of this multiset, grouped into `Multiset.Entry` instances, each providing an element of the multiset and the count of that element.
    `Multiset.Entry<E>` | `firstEntry()` Returns the entry of the first element in this multiset, or `null` if this multiset is empty.
    `SortedMultiset<E>` | `headMultiset(E toElement, BoundType boundType)` Returns a view of this multiset restricted to the elements less than `upperBound`, optionally including `upperBound` itself.
    `java.util.Iterator<E>` | `iterator()`
    `Multiset.Entry<E>` | `lastEntry()` Returns the entry of the last element in this multiset, or `null` if this multiset is empty.
    `Multiset.Entry<E>` | `pollFirstEntry()` Returns and removes the entry associated with the lowest element in this multiset, or returns `null` if this multiset is empty.
    `Multiset.Entry<E>` | `pollLastEntry()` Returns and removes the entry associated with the greatest element in this multiset, or returns `null` if this multiset is empty.
    `SortedMultiset<E>` | `subMultiset(E fromElement, BoundType fromBoundType, E toElement, BoundType toBoundType)` Returns a view of this multiset restricted to the range between `lowerBound` and `upperBound`.
    `SortedMultiset<E>` | `tailMultiset(E fromElement, BoundType boundType)` Returns a view of this multiset restricted to the elements greater than `lowerBound`, optionally including `lowerBound` itself.
    `java.lang.Object[]` | `toArray()`
    `<T> T[]` | `toArray(T[] array)`
    `java.lang.String` | `toString()` Returns the string representation generated by the delegate's `toString` method.

    - ### Methods inherited from class com.google.common.collect.ForwardingMultiset

      `add, count, equals, hashCode, remove, setCount, setCount, standardAdd, standardAddAll, standardClear, standardContains, standardCount, standardEquals, standardHashCode, standardIterator, standardRemove, standardRemoveAll, standardRetainAll, standardSetCount, standardSetCount, standardSize, standardToString`

    - ### Methods inherited from class com.google.common.collect.ForwardingCollection

      `add, addAll, clear, contains, containsAll, isEmpty, remove, removeAll, retainAll, size, standardContainsAll, standardIsEmpty, standardToArray, standardToArray`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface com.google.common.collect.Multiset

      `add, add, contains, containsAll, count, equals, hashCode, remove, remove, removeAll, retainAll, setCount, setCount`

    - ### Methods inherited from interface java.util.Collection

      `addAll, clear, isEmpty, size`

- - ### Constructor Detail

    - #### ForwardingSortedMultiset.StandardDescendingMultiset

          public ForwardingSortedMultiset.StandardDescendingMultiset()

      Constructor for use by subclasses.

  - ### Method Detail

    - #### comparator

          public java.util.Comparator<? super E> comparator()

      Description copied from interface: `SortedMultiset`
      Returns the comparator that orders this multiset, or `Ordering.natural()` if the natural ordering of the elements is used.
      Specified by:
        `comparator` in interface `SortedMultiset<E>`

    - #### elementSet

          public java.util.NavigableSet<E> elementSet()

      Description copied from interface: `Multiset`
      Returns the set of distinct elements contained in this multiset. The element set is backed by the same data as the multiset, so any change to either is immediately reflected in the other. The order of the elements in the element set is unspecified.

      If the element set supports any removal operations, these necessarily cause all occurrences of the removed element(s) to be removed from the multiset. Implementations are not expected to support the add operations, although this is possible.

      A common use for the element set is to find the number of distinct elements in the multiset: `elementSet().size()`.

      Specified by:
        `elementSet` in interface `Multiset<E>`
      Specified by:
        `elementSet` in interface `SortedMultiset<E>`
      Overrides:
        `elementSet` in class `ForwardingMultiset<E>`
      Returns:
        a view of the set of distinct elements in this multiset

    - #### pollFirstEntry

          public Multiset.Entry<E> pollFirstEntry()

      Description copied from interface: `SortedMultiset`
      Returns and removes the entry associated with the lowest element in this multiset, or returns `null` if this multiset is empty.
      Specified by:
        `pollFirstEntry` in interface `SortedMultiset<E>`

    - #### pollLastEntry

          public Multiset.Entry<E> pollLastEntry()

      Description copied from interface: `SortedMultiset`
      Returns and removes the entry associated with the greatest element in this multiset, or returns `null` if this multiset is empty.
      Specified by:
        `pollLastEntry` in interface `SortedMultiset<E>`

    - #### headMultiset

          public SortedMultiset<E> headMultiset(E toElement,
                                       BoundType boundType)

      Description copied from interface: `SortedMultiset`
      Returns a view of this multiset restricted to the elements less than `upperBound`, optionally including `upperBound` itself. The returned multiset is a view of this multiset, so changes to one will be reflected in the other. The returned multiset supports all operations that this multiset supports.

      The returned multiset will throw an `IllegalArgumentException` on attempts to add elements outside its range.

      Specified by:
        `headMultiset` in interface `SortedMultiset<E>`

    - #### subMultiset

          public SortedMultiset<E> subMultiset(E fromElement,
                                      BoundType fromBoundType,
                                      E toElement,
                                      BoundType toBoundType)

      Description copied from interface: `SortedMultiset`
      Returns a view of this multiset restricted to the range between `lowerBound` and `upperBound`. The returned multiset is a view of this multiset, so changes to one will be reflected in the other. The returned multiset supports all operations that this multiset supports.

      The returned multiset will throw an `IllegalArgumentException` on attempts to add elements outside its range.

      This method is equivalent to `tailMultiset(lowerBound, lowerBoundType).headMultiset(upperBound, upperBoundType)`.

      Specified by:
        `subMultiset` in interface `SortedMultiset<E>`

    - #### tailMultiset

          public SortedMultiset<E> tailMultiset(E fromElement,
                                       BoundType boundType)

      Description copied from interface: `SortedMultiset`
      Returns a view of this multiset restricted to the elements greater than `lowerBound`, optionally including `lowerBound` itself. The returned multiset is a view of this multiset, so changes to one will be reflected in the other. The returned multiset supports all operations that this multiset supports.

      The returned multiset will throw an `IllegalArgumentException` on attempts to add elements outside its range.

      Specified by:
        `tailMultiset` in interface `SortedMultiset<E>`

    - #### delegate

          protected Multiset<E> delegate()

      Description copied from class: `ForwardingObject`
      Returns the backing delegate instance that methods are forwarded to. Abstract subclasses generally override this method with an abstract method that has a more specific return type, such as `ForwardingSet.delegate()`. Concrete subclasses override this method to supply the instance being decorated.
      Specified by:
        `delegate` in class `ForwardingMultiset<E>`

    - #### descendingMultiset

          public SortedMultiset<E> descendingMultiset()

      Description copied from interface: `SortedMultiset`
      Returns a descending view of this multiset. Modifications made to either map will be reflected in the other.
      Specified by:
        `descendingMultiset` in interface `SortedMultiset<E>`

    - #### firstEntry

          public Multiset.Entry<E> firstEntry()

      Description copied from interface: `SortedMultiset`
      Returns the entry of the first element in this multiset, or `null` if this multiset is empty.
      Specified by:
        `firstEntry` in interface `SortedMultiset<E>`

    - #### lastEntry

          public Multiset.Entry<E> lastEntry()

      Description copied from interface: `SortedMultiset`
      Returns the entry of the last element in this multiset, or `null` if this multiset is empty.
      Specified by:
        `lastEntry` in interface `SortedMultiset<E>`

    - #### entrySet

          public java.util.Set<Multiset.Entry<E>> entrySet()

      Description copied from interface: `Multiset`
      Returns a view of the contents of this multiset, grouped into `Multiset.Entry` instances, each providing an element of the multiset and the count of that element. This set contains exactly one entry for each distinct element in the multiset (thus it always has the same size as the `Multiset.elementSet()`). The order of the elements in the element set is unspecified.

      The entry set is backed by the same data as the multiset, so any change to either is immediately reflected in the other. However, multiset changes may or may not be reflected in any `Entry` instances already retrieved from the entry set (this is implementation-dependent). Furthermore, implementations are not required to support modifications to the entry set at all, and the `Entry` instances themselves don't even have methods for modification. See the specific implementation class for more details on how its entry set handles modifications.

      Specified by:
        `entrySet` in interface `Multiset<E>`
      Specified by:
        `entrySet` in interface `SortedMultiset<E>`
      Overrides:
        `entrySet` in class `ForwardingMultiset<E>`
      Returns:
        a set of entries representing the data of this multiset

    - #### iterator

          public java.util.Iterator<E> iterator()

      Description copied from interface: `SortedMultiset`

      Elements that occur multiple times in the multiset will appear multiple times in this iterator, though not necessarily sequentially.

      The iterator returns the elements in ascending order according to this multiset's comparator.

      Specified by:
        `iterator` in interface `Multiset<E>`
      Specified by:
        `iterator` in interface `SortedMultiset<E>`
      Specified by:
        `iterator` in interface `java.lang.Iterable<E>`
      Specified by:
        `iterator` in interface `java.util.Collection<E>`
      Overrides:
        `iterator` in class `ForwardingCollection<E>`

    - #### toArray

          public java.lang.Object[] toArray()

      Specified by:
        `toArray` in interface `java.util.Collection<E>`
      Overrides:
        `toArray` in class `ForwardingCollection<E>`

    - #### toArray

          public <T> T[] toArray(T[] array)

      Specified by:
        `toArray` in interface `java.util.Collection<E>`
      Overrides:
        `toArray` in class `ForwardingCollection<E>`

    - #### toString

          public java.lang.String toString()

      Description copied from class: `ForwardingObject`
      Returns the string representation generated by the delegate's `toString` method.
      Specified by:
        `toString` in interface `Multiset<E>`
      Overrides:
        `toString` in class `ForwardingObject`